// LineDlg.cpp : implementation file
//

#include "stdafx.h"
#include "LineDemo.h"
#include "LineDlg.h"
#include "Line3D.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define TIMER_ID 123
/////////////////////////////////////////////////////////////////////////////
// CLineDemoDlg dialog

CLineDemoDlg::CLineDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLineDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLineDemoDlg)
	m_solid = -1;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CLineDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLineDemoDlg)
	DDX_Radio(pDX, IDC_SOLID, m_solid);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CLineDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CLineDemoDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_DASH, OnDash)
	ON_BN_CLICKED(IDC_DASHDOT, OnDashdot)
	ON_BN_CLICKED(IDC_DASHDOTDOT, OnDashdotdot)
	ON_BN_CLICKED(IDC_DOT, OnDot)
	ON_BN_CLICKED(IDC_SOLID, OnSolid)
	ON_WM_DESTROY()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLineDemoDlg message handlers

BOOL CLineDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_uTimer = 0;
	m_solid = 0;
	m_iTime = 0;

	RECT r;
	GetDlgItem(IDC_LINE1)->GetClientRect(&r);
	m_iLimit = r.right;
	m_iDirection = m_iLimit / 20;
	
	SetTimer(TIMER_ID, 100, NULL);
	((CButton*)GetDlgItem(IDC_SOLID))->SetCheck(TRUE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CLineDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CLineDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CLineDemoDlg::OnDash() 
{
	m_solid = 1;
	SetLineStyle();
}

void CLineDemoDlg::OnDashdot() 
{
	m_solid = 3;
	SetLineStyle();
}

void CLineDemoDlg::OnDashdotdot() 
{
	m_solid = 4;
	SetLineStyle();
}

void CLineDemoDlg::OnDot() 
{
	m_solid = 2;
	SetLineStyle();
}

void CLineDemoDlg::OnSolid() 
{
	m_solid = 0;
	SetLineStyle();
}

void CLineDemoDlg::OnDestroy() 
{
	KillTimer(TIMER_ID);
	CDialog::OnDestroy();
}

void CLineDemoDlg::OnTimer(UINT nIDEvent) 
{
	CDialog::OnTimer(nIDEvent);
	int right, bottom;
	if(m_iTime > 0)
	{
		right = m_iLimit - m_iTime;
		bottom = m_iLimit;
	}
	else
	{
		right = m_iLimit;
		bottom = m_iLimit + m_iTime;
	}
	GetDlgItem(IDC_LINE1)->SetWindowPos(&wndTop, 0, 0, 
		right, bottom, SWP_NOMOVE | SWP_NOZORDER);
	GetDlgItem(IDC_LINE2)->SetWindowPos(&wndTop, 0, 0, 
		right, bottom, SWP_NOMOVE | SWP_NOZORDER);
	m_iTime = m_iTime + m_iDirection;
	if(m_iTime >= m_iLimit)
	{
		m_iDirection = -m_iDirection;
		m_iTime = m_iLimit;
	}
	if(m_iTime <= -m_iLimit)
	{
		m_iDirection = -m_iDirection;
		m_iTime = -m_iLimit;
	}
}

void CLineDemoDlg::SetLineStyle()
{
	((CLine3D*)GetDlgItem(IDC_LINE1))->SetLineStyle(m_solid);
	((CLine3D*)GetDlgItem(IDC_LINE2))->SetLineStyle(m_solid);
	((CLine3D*)GetDlgItem(IDC_LINE3))->SetLineStyle(m_solid);
	((CLine3D*)GetDlgItem(IDC_LINE4))->SetLineStyle(m_solid);
	((CLine3D*)GetDlgItem(IDC_LINE5))->SetLineStyle(m_solid);
	((CLine3D*)GetDlgItem(IDC_LINE6))->SetLineStyle(m_solid);
	((CLine3D*)GetDlgItem(IDC_LINE7))->SetLineStyle(m_solid);
	((CLine3D*)GetDlgItem(IDC_LINE8))->SetLineStyle(m_solid);
	((CLine3D*)GetDlgItem(IDC_LINE9))->SetLineStyle(m_solid);
	((CLine3D*)GetDlgItem(IDC_LINE10))->SetLineStyle(m_solid);
}
